object Anagram {
  def letterCount(s: String): Map[Char, Int] =
    s.foldLeft(Map[Char, Int]().withDefault(_ => 0))((res, cur) =>
      res + (cur -> (res(cur) + 1)))

  def areAnagrams(w1: String, w2: String): Boolean =
    letterCount(w1) == letterCount(w2)

  def anagrams(words: Seq[String]): Set[Set[String]] =
    words.foldLeft(Map[Map[Char, Int], Set[String]]().withDefault(_ => Set[String]()))(
      (res, cur) => {
        val counts = letterCount(cur)
        res + (counts -> (res(counts) + cur))
      }).values.filter(_.size > 1).toSet
}
