object FactorialAccum {
  // since the recursive call is the last thing the function does,
  // this function doesn't actually need to keep around anything on the
  // stack.  As such, the compiler can perform a tail-call optimization,
  // allowing the function to consume a constant amount of stack space.
  // You may want to look at
  // http://en.wikipedia.org/wiki/Tail_call for more information
  def factorial(n: BigInt): BigInt = {
    def fact(n: BigInt, accum: BigInt): BigInt =
      if (n == 0) accum
      else fact(n - 1, n * accum)
    fact(n, 1)
  }
}
