object PrimeNumbers {
  def isPrime(num: Int): Boolean = 
    (2 to math.sqrt(num).toInt).forall(divisor => num % divisor != 0)

  def positiveIntegers(): Stream[Int] = {
    def withStart(start: Int): Stream[Int] =
      Stream.cons(start, withStart(start + 1))
    withStart(1)
  }

  def firstNPrimes(n: Int): Seq[Int] =
    positiveIntegers.tail.filter(isPrime).take(n).toList
}

